﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace CsrfExample.Controllers
{
    public class TestController : Controller
    {
        private const string _filename = "tmp.dat";

        //
        // GET: /Test/
        public ActionResult Index()
        {
            if (!System.IO.File.Exists(_filename))
            {
                WriteTitles(new[] { "" });
            }

            return View(ReadTitles());
        }

        private string[] ReadTitles()
        {
            var text = System.IO.File.ReadAllText(_filename);

            return text.Split(new[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
        }

        private void WriteTitles(IEnumerable<string> titles)
        {
            var result = "";
            foreach (var title in titles)
            {
                result += title + Environment.NewLine;
            }
            System.IO.File.WriteAllText(_filename, result);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(string title)
        {
            var titles = ReadTitles();
            var filteredTitles = titles.Where(x => x != title).ToList();
            WriteTitles(filteredTitles);

            return RedirectToAction("Index");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Add(string title)
        {
            var titles = ReadTitles();
            var listOfTitles = titles.ToList();
            listOfTitles.Add(title);

            WriteTitles(listOfTitles);

            return RedirectToAction("Index");
        }
    }

    public static class Extensions
    {
        private static Random _random = null;
        private static Random Random
        {
            get
            {
                return _random ?? (_random = new Random());
            }
        }
        public static string Guid(this HtmlHelper helper)
        {
            var bytes = new byte[16];
            Random.NextBytes(bytes);

            return new Guid(bytes).ToString();
        }

        public static IDictionary<string, object> MergeWith(this IDictionary<string, object> dict, object values)
        {
            var valuesDict = HtmlHelper.AnonymousObjectToHtmlAttributes(values);
            foreach (var keyValuePair in valuesDict)
            {
                dict[keyValuePair.Key] = keyValuePair.Value;
            }

            return dict;
        }
    }
}
